from __future__ import with_statement
print "b0"
os.chdir("/home/was/sd5/sato-tate/sage_notebook/worksheets/admin/2/cells/1")
#auto
def dist(v, b, left=-1.0, right=1.0):
    """
    We divide the interval between left (default: 0) and
    right (default: pi) up into b bins.

    For each number in v (which must left and right),
    we find which bin it lies in and add this to a counter.
    This function then returns the bins and the number of
    elements of v that lie in each one.

    ALGORITHM: To find the index of the bin that a given
    number x lies in, we multiply x by b/length and take the
    floor.
    """
    length = right - left
    normalize = float(b/length)
    vals = {}
    d = dict([(i,Integer(0)) for i in range(b)])
    for x in v:
        n = int(normalize*(float(x)-left))
        d[n] += Integer(1)
    return d, len(v)

def frequency_histogram(d, b, num=Integer(5000), left=-1.0, right=1.0):
    s = Graphics()
    left = float(left); right = float(right)
    length = right - left
    w = length/b
    k = Integer(0)
    for i, n in d.iteritems():
        k += n
        # ith bin has n objects in it.
        s += polygon([(w*i+left,Integer(0)), (w*(i+Integer(1))+left,Integer(0)),                      (w*(i+Integer(1))+left, n/(num*w)), (w*i+left, n/(num*w))],\
                     rgbcolor=(Integer(0),Integer(0),RealNumber('0.5')))
    return s

def semicircle0():
    alpha = 2.0 / float(pi)
    def f(x):
        return alpha * math.sqrt(Integer(1)-x**Integer(2))
    return plot(f, -Integer(1),Integer(1),rgbcolor=(RealNumber('0.5'),Integer(0),Integer(0)))
exec compile(ur'semicircle = semicircle0()' + '\n', '', 'single')

print "e0"
